// Code generated by ent, DO NOT EDIT.

package token

import (
	"time"
	"wechat-api/ent/predicate"

	"entgo.io/ent/dialect/sql"
	"entgo.io/ent/dialect/sql/sqlgraph"
)

// ID filters vertices based on their ID field.
func ID(id uint64) predicate.Token {
	return predicate.Token(sql.FieldEQ(FieldID, id))
}

// IDEQ applies the EQ predicate on the ID field.
func IDEQ(id uint64) predicate.Token {
	return predicate.Token(sql.FieldEQ(FieldID, id))
}

// IDNEQ applies the NEQ predicate on the ID field.
func IDNEQ(id uint64) predicate.Token {
	return predicate.Token(sql.FieldNEQ(FieldID, id))
}

// IDIn applies the In predicate on the ID field.
func IDIn(ids ...uint64) predicate.Token {
	return predicate.Token(sql.FieldIn(FieldID, ids...))
}

// IDNotIn applies the NotIn predicate on the ID field.
func IDNotIn(ids ...uint64) predicate.Token {
	return predicate.Token(sql.FieldNotIn(FieldID, ids...))
}

// IDGT applies the GT predicate on the ID field.
func IDGT(id uint64) predicate.Token {
	return predicate.Token(sql.FieldGT(FieldID, id))
}

// IDGTE applies the GTE predicate on the ID field.
func IDGTE(id uint64) predicate.Token {
	return predicate.Token(sql.FieldGTE(FieldID, id))
}

// IDLT applies the LT predicate on the ID field.
func IDLT(id uint64) predicate.Token {
	return predicate.Token(sql.FieldLT(FieldID, id))
}

// IDLTE applies the LTE predicate on the ID field.
func IDLTE(id uint64) predicate.Token {
	return predicate.Token(sql.FieldLTE(FieldID, id))
}

// CreatedAt applies equality check predicate on the "created_at" field. It's identical to CreatedAtEQ.
func CreatedAt(v time.Time) predicate.Token {
	return predicate.Token(sql.FieldEQ(FieldCreatedAt, v))
}

// UpdatedAt applies equality check predicate on the "updated_at" field. It's identical to UpdatedAtEQ.
func UpdatedAt(v time.Time) predicate.Token {
	return predicate.Token(sql.FieldEQ(FieldUpdatedAt, v))
}

// DeletedAt applies equality check predicate on the "deleted_at" field. It's identical to DeletedAtEQ.
func DeletedAt(v time.Time) predicate.Token {
	return predicate.Token(sql.FieldEQ(FieldDeletedAt, v))
}

// ExpireAt applies equality check predicate on the "expire_at" field. It's identical to ExpireAtEQ.
func ExpireAt(v time.Time) predicate.Token {
	return predicate.Token(sql.FieldEQ(FieldExpireAt, v))
}

// Token applies equality check predicate on the "token" field. It's identical to TokenEQ.
func Token(v string) predicate.Token {
	return predicate.Token(sql.FieldEQ(FieldToken, v))
}

// MAC applies equality check predicate on the "mac" field. It's identical to MACEQ.
func MAC(v string) predicate.Token {
	return predicate.Token(sql.FieldEQ(FieldMAC, v))
}

// OrganizationID applies equality check predicate on the "organization_id" field. It's identical to OrganizationIDEQ.
func OrganizationID(v uint64) predicate.Token {
	return predicate.Token(sql.FieldEQ(FieldOrganizationID, v))
}

// AgentID applies equality check predicate on the "agent_id" field. It's identical to AgentIDEQ.
func AgentID(v uint64) predicate.Token {
	return predicate.Token(sql.FieldEQ(FieldAgentID, v))
}

// CustomAgentBase applies equality check predicate on the "custom_agent_base" field. It's identical to CustomAgentBaseEQ.
func CustomAgentBase(v string) predicate.Token {
	return predicate.Token(sql.FieldEQ(FieldCustomAgentBase, v))
}

// CustomAgentKey applies equality check predicate on the "custom_agent_key" field. It's identical to CustomAgentKeyEQ.
func CustomAgentKey(v string) predicate.Token {
	return predicate.Token(sql.FieldEQ(FieldCustomAgentKey, v))
}

// OpenaiBase applies equality check predicate on the "openai_base" field. It's identical to OpenaiBaseEQ.
func OpenaiBase(v string) predicate.Token {
	return predicate.Token(sql.FieldEQ(FieldOpenaiBase, v))
}

// OpenaiKey applies equality check predicate on the "openai_key" field. It's identical to OpenaiKeyEQ.
func OpenaiKey(v string) predicate.Token {
	return predicate.Token(sql.FieldEQ(FieldOpenaiKey, v))
}

// CreatedAtEQ applies the EQ predicate on the "created_at" field.
func CreatedAtEQ(v time.Time) predicate.Token {
	return predicate.Token(sql.FieldEQ(FieldCreatedAt, v))
}

// CreatedAtNEQ applies the NEQ predicate on the "created_at" field.
func CreatedAtNEQ(v time.Time) predicate.Token {
	return predicate.Token(sql.FieldNEQ(FieldCreatedAt, v))
}

// CreatedAtIn applies the In predicate on the "created_at" field.
func CreatedAtIn(vs ...time.Time) predicate.Token {
	return predicate.Token(sql.FieldIn(FieldCreatedAt, vs...))
}

// CreatedAtNotIn applies the NotIn predicate on the "created_at" field.
func CreatedAtNotIn(vs ...time.Time) predicate.Token {
	return predicate.Token(sql.FieldNotIn(FieldCreatedAt, vs...))
}

// CreatedAtGT applies the GT predicate on the "created_at" field.
func CreatedAtGT(v time.Time) predicate.Token {
	return predicate.Token(sql.FieldGT(FieldCreatedAt, v))
}

// CreatedAtGTE applies the GTE predicate on the "created_at" field.
func CreatedAtGTE(v time.Time) predicate.Token {
	return predicate.Token(sql.FieldGTE(FieldCreatedAt, v))
}

// CreatedAtLT applies the LT predicate on the "created_at" field.
func CreatedAtLT(v time.Time) predicate.Token {
	return predicate.Token(sql.FieldLT(FieldCreatedAt, v))
}

// CreatedAtLTE applies the LTE predicate on the "created_at" field.
func CreatedAtLTE(v time.Time) predicate.Token {
	return predicate.Token(sql.FieldLTE(FieldCreatedAt, v))
}

// UpdatedAtEQ applies the EQ predicate on the "updated_at" field.
func UpdatedAtEQ(v time.Time) predicate.Token {
	return predicate.Token(sql.FieldEQ(FieldUpdatedAt, v))
}

// UpdatedAtNEQ applies the NEQ predicate on the "updated_at" field.
func UpdatedAtNEQ(v time.Time) predicate.Token {
	return predicate.Token(sql.FieldNEQ(FieldUpdatedAt, v))
}

// UpdatedAtIn applies the In predicate on the "updated_at" field.
func UpdatedAtIn(vs ...time.Time) predicate.Token {
	return predicate.Token(sql.FieldIn(FieldUpdatedAt, vs...))
}

// UpdatedAtNotIn applies the NotIn predicate on the "updated_at" field.
func UpdatedAtNotIn(vs ...time.Time) predicate.Token {
	return predicate.Token(sql.FieldNotIn(FieldUpdatedAt, vs...))
}

// UpdatedAtGT applies the GT predicate on the "updated_at" field.
func UpdatedAtGT(v time.Time) predicate.Token {
	return predicate.Token(sql.FieldGT(FieldUpdatedAt, v))
}

// UpdatedAtGTE applies the GTE predicate on the "updated_at" field.
func UpdatedAtGTE(v time.Time) predicate.Token {
	return predicate.Token(sql.FieldGTE(FieldUpdatedAt, v))
}

// UpdatedAtLT applies the LT predicate on the "updated_at" field.
func UpdatedAtLT(v time.Time) predicate.Token {
	return predicate.Token(sql.FieldLT(FieldUpdatedAt, v))
}

// UpdatedAtLTE applies the LTE predicate on the "updated_at" field.
func UpdatedAtLTE(v time.Time) predicate.Token {
	return predicate.Token(sql.FieldLTE(FieldUpdatedAt, v))
}

// DeletedAtEQ applies the EQ predicate on the "deleted_at" field.
func DeletedAtEQ(v time.Time) predicate.Token {
	return predicate.Token(sql.FieldEQ(FieldDeletedAt, v))
}

// DeletedAtNEQ applies the NEQ predicate on the "deleted_at" field.
func DeletedAtNEQ(v time.Time) predicate.Token {
	return predicate.Token(sql.FieldNEQ(FieldDeletedAt, v))
}

// DeletedAtIn applies the In predicate on the "deleted_at" field.
func DeletedAtIn(vs ...time.Time) predicate.Token {
	return predicate.Token(sql.FieldIn(FieldDeletedAt, vs...))
}

// DeletedAtNotIn applies the NotIn predicate on the "deleted_at" field.
func DeletedAtNotIn(vs ...time.Time) predicate.Token {
	return predicate.Token(sql.FieldNotIn(FieldDeletedAt, vs...))
}

// DeletedAtGT applies the GT predicate on the "deleted_at" field.
func DeletedAtGT(v time.Time) predicate.Token {
	return predicate.Token(sql.FieldGT(FieldDeletedAt, v))
}

// DeletedAtGTE applies the GTE predicate on the "deleted_at" field.
func DeletedAtGTE(v time.Time) predicate.Token {
	return predicate.Token(sql.FieldGTE(FieldDeletedAt, v))
}

// DeletedAtLT applies the LT predicate on the "deleted_at" field.
func DeletedAtLT(v time.Time) predicate.Token {
	return predicate.Token(sql.FieldLT(FieldDeletedAt, v))
}

// DeletedAtLTE applies the LTE predicate on the "deleted_at" field.
func DeletedAtLTE(v time.Time) predicate.Token {
	return predicate.Token(sql.FieldLTE(FieldDeletedAt, v))
}

// DeletedAtIsNil applies the IsNil predicate on the "deleted_at" field.
func DeletedAtIsNil() predicate.Token {
	return predicate.Token(sql.FieldIsNull(FieldDeletedAt))
}

// DeletedAtNotNil applies the NotNil predicate on the "deleted_at" field.
func DeletedAtNotNil() predicate.Token {
	return predicate.Token(sql.FieldNotNull(FieldDeletedAt))
}

// ExpireAtEQ applies the EQ predicate on the "expire_at" field.
func ExpireAtEQ(v time.Time) predicate.Token {
	return predicate.Token(sql.FieldEQ(FieldExpireAt, v))
}

// ExpireAtNEQ applies the NEQ predicate on the "expire_at" field.
func ExpireAtNEQ(v time.Time) predicate.Token {
	return predicate.Token(sql.FieldNEQ(FieldExpireAt, v))
}

// ExpireAtIn applies the In predicate on the "expire_at" field.
func ExpireAtIn(vs ...time.Time) predicate.Token {
	return predicate.Token(sql.FieldIn(FieldExpireAt, vs...))
}

// ExpireAtNotIn applies the NotIn predicate on the "expire_at" field.
func ExpireAtNotIn(vs ...time.Time) predicate.Token {
	return predicate.Token(sql.FieldNotIn(FieldExpireAt, vs...))
}

// ExpireAtGT applies the GT predicate on the "expire_at" field.
func ExpireAtGT(v time.Time) predicate.Token {
	return predicate.Token(sql.FieldGT(FieldExpireAt, v))
}

// ExpireAtGTE applies the GTE predicate on the "expire_at" field.
func ExpireAtGTE(v time.Time) predicate.Token {
	return predicate.Token(sql.FieldGTE(FieldExpireAt, v))
}

// ExpireAtLT applies the LT predicate on the "expire_at" field.
func ExpireAtLT(v time.Time) predicate.Token {
	return predicate.Token(sql.FieldLT(FieldExpireAt, v))
}

// ExpireAtLTE applies the LTE predicate on the "expire_at" field.
func ExpireAtLTE(v time.Time) predicate.Token {
	return predicate.Token(sql.FieldLTE(FieldExpireAt, v))
}

// ExpireAtIsNil applies the IsNil predicate on the "expire_at" field.
func ExpireAtIsNil() predicate.Token {
	return predicate.Token(sql.FieldIsNull(FieldExpireAt))
}

// ExpireAtNotNil applies the NotNil predicate on the "expire_at" field.
func ExpireAtNotNil() predicate.Token {
	return predicate.Token(sql.FieldNotNull(FieldExpireAt))
}

// TokenEQ applies the EQ predicate on the "token" field.
func TokenEQ(v string) predicate.Token {
	return predicate.Token(sql.FieldEQ(FieldToken, v))
}

// TokenNEQ applies the NEQ predicate on the "token" field.
func TokenNEQ(v string) predicate.Token {
	return predicate.Token(sql.FieldNEQ(FieldToken, v))
}

// TokenIn applies the In predicate on the "token" field.
func TokenIn(vs ...string) predicate.Token {
	return predicate.Token(sql.FieldIn(FieldToken, vs...))
}

// TokenNotIn applies the NotIn predicate on the "token" field.
func TokenNotIn(vs ...string) predicate.Token {
	return predicate.Token(sql.FieldNotIn(FieldToken, vs...))
}

// TokenGT applies the GT predicate on the "token" field.
func TokenGT(v string) predicate.Token {
	return predicate.Token(sql.FieldGT(FieldToken, v))
}

// TokenGTE applies the GTE predicate on the "token" field.
func TokenGTE(v string) predicate.Token {
	return predicate.Token(sql.FieldGTE(FieldToken, v))
}

// TokenLT applies the LT predicate on the "token" field.
func TokenLT(v string) predicate.Token {
	return predicate.Token(sql.FieldLT(FieldToken, v))
}

// TokenLTE applies the LTE predicate on the "token" field.
func TokenLTE(v string) predicate.Token {
	return predicate.Token(sql.FieldLTE(FieldToken, v))
}

// TokenContains applies the Contains predicate on the "token" field.
func TokenContains(v string) predicate.Token {
	return predicate.Token(sql.FieldContains(FieldToken, v))
}

// TokenHasPrefix applies the HasPrefix predicate on the "token" field.
func TokenHasPrefix(v string) predicate.Token {
	return predicate.Token(sql.FieldHasPrefix(FieldToken, v))
}

// TokenHasSuffix applies the HasSuffix predicate on the "token" field.
func TokenHasSuffix(v string) predicate.Token {
	return predicate.Token(sql.FieldHasSuffix(FieldToken, v))
}

// TokenIsNil applies the IsNil predicate on the "token" field.
func TokenIsNil() predicate.Token {
	return predicate.Token(sql.FieldIsNull(FieldToken))
}

// TokenNotNil applies the NotNil predicate on the "token" field.
func TokenNotNil() predicate.Token {
	return predicate.Token(sql.FieldNotNull(FieldToken))
}

// TokenEqualFold applies the EqualFold predicate on the "token" field.
func TokenEqualFold(v string) predicate.Token {
	return predicate.Token(sql.FieldEqualFold(FieldToken, v))
}

// TokenContainsFold applies the ContainsFold predicate on the "token" field.
func TokenContainsFold(v string) predicate.Token {
	return predicate.Token(sql.FieldContainsFold(FieldToken, v))
}

// MACEQ applies the EQ predicate on the "mac" field.
func MACEQ(v string) predicate.Token {
	return predicate.Token(sql.FieldEQ(FieldMAC, v))
}

// MACNEQ applies the NEQ predicate on the "mac" field.
func MACNEQ(v string) predicate.Token {
	return predicate.Token(sql.FieldNEQ(FieldMAC, v))
}

// MACIn applies the In predicate on the "mac" field.
func MACIn(vs ...string) predicate.Token {
	return predicate.Token(sql.FieldIn(FieldMAC, vs...))
}

// MACNotIn applies the NotIn predicate on the "mac" field.
func MACNotIn(vs ...string) predicate.Token {
	return predicate.Token(sql.FieldNotIn(FieldMAC, vs...))
}

// MACGT applies the GT predicate on the "mac" field.
func MACGT(v string) predicate.Token {
	return predicate.Token(sql.FieldGT(FieldMAC, v))
}

// MACGTE applies the GTE predicate on the "mac" field.
func MACGTE(v string) predicate.Token {
	return predicate.Token(sql.FieldGTE(FieldMAC, v))
}

// MACLT applies the LT predicate on the "mac" field.
func MACLT(v string) predicate.Token {
	return predicate.Token(sql.FieldLT(FieldMAC, v))
}

// MACLTE applies the LTE predicate on the "mac" field.
func MACLTE(v string) predicate.Token {
	return predicate.Token(sql.FieldLTE(FieldMAC, v))
}

// MACContains applies the Contains predicate on the "mac" field.
func MACContains(v string) predicate.Token {
	return predicate.Token(sql.FieldContains(FieldMAC, v))
}

// MACHasPrefix applies the HasPrefix predicate on the "mac" field.
func MACHasPrefix(v string) predicate.Token {
	return predicate.Token(sql.FieldHasPrefix(FieldMAC, v))
}

// MACHasSuffix applies the HasSuffix predicate on the "mac" field.
func MACHasSuffix(v string) predicate.Token {
	return predicate.Token(sql.FieldHasSuffix(FieldMAC, v))
}

// MACIsNil applies the IsNil predicate on the "mac" field.
func MACIsNil() predicate.Token {
	return predicate.Token(sql.FieldIsNull(FieldMAC))
}

// MACNotNil applies the NotNil predicate on the "mac" field.
func MACNotNil() predicate.Token {
	return predicate.Token(sql.FieldNotNull(FieldMAC))
}

// MACEqualFold applies the EqualFold predicate on the "mac" field.
func MACEqualFold(v string) predicate.Token {
	return predicate.Token(sql.FieldEqualFold(FieldMAC, v))
}

// MACContainsFold applies the ContainsFold predicate on the "mac" field.
func MACContainsFold(v string) predicate.Token {
	return predicate.Token(sql.FieldContainsFold(FieldMAC, v))
}

// OrganizationIDEQ applies the EQ predicate on the "organization_id" field.
func OrganizationIDEQ(v uint64) predicate.Token {
	return predicate.Token(sql.FieldEQ(FieldOrganizationID, v))
}

// OrganizationIDNEQ applies the NEQ predicate on the "organization_id" field.
func OrganizationIDNEQ(v uint64) predicate.Token {
	return predicate.Token(sql.FieldNEQ(FieldOrganizationID, v))
}

// OrganizationIDIn applies the In predicate on the "organization_id" field.
func OrganizationIDIn(vs ...uint64) predicate.Token {
	return predicate.Token(sql.FieldIn(FieldOrganizationID, vs...))
}

// OrganizationIDNotIn applies the NotIn predicate on the "organization_id" field.
func OrganizationIDNotIn(vs ...uint64) predicate.Token {
	return predicate.Token(sql.FieldNotIn(FieldOrganizationID, vs...))
}

// OrganizationIDGT applies the GT predicate on the "organization_id" field.
func OrganizationIDGT(v uint64) predicate.Token {
	return predicate.Token(sql.FieldGT(FieldOrganizationID, v))
}

// OrganizationIDGTE applies the GTE predicate on the "organization_id" field.
func OrganizationIDGTE(v uint64) predicate.Token {
	return predicate.Token(sql.FieldGTE(FieldOrganizationID, v))
}

// OrganizationIDLT applies the LT predicate on the "organization_id" field.
func OrganizationIDLT(v uint64) predicate.Token {
	return predicate.Token(sql.FieldLT(FieldOrganizationID, v))
}

// OrganizationIDLTE applies the LTE predicate on the "organization_id" field.
func OrganizationIDLTE(v uint64) predicate.Token {
	return predicate.Token(sql.FieldLTE(FieldOrganizationID, v))
}

// AgentIDEQ applies the EQ predicate on the "agent_id" field.
func AgentIDEQ(v uint64) predicate.Token {
	return predicate.Token(sql.FieldEQ(FieldAgentID, v))
}

// AgentIDNEQ applies the NEQ predicate on the "agent_id" field.
func AgentIDNEQ(v uint64) predicate.Token {
	return predicate.Token(sql.FieldNEQ(FieldAgentID, v))
}

// AgentIDIn applies the In predicate on the "agent_id" field.
func AgentIDIn(vs ...uint64) predicate.Token {
	return predicate.Token(sql.FieldIn(FieldAgentID, vs...))
}

// AgentIDNotIn applies the NotIn predicate on the "agent_id" field.
func AgentIDNotIn(vs ...uint64) predicate.Token {
	return predicate.Token(sql.FieldNotIn(FieldAgentID, vs...))
}

// CustomAgentBaseEQ applies the EQ predicate on the "custom_agent_base" field.
func CustomAgentBaseEQ(v string) predicate.Token {
	return predicate.Token(sql.FieldEQ(FieldCustomAgentBase, v))
}

// CustomAgentBaseNEQ applies the NEQ predicate on the "custom_agent_base" field.
func CustomAgentBaseNEQ(v string) predicate.Token {
	return predicate.Token(sql.FieldNEQ(FieldCustomAgentBase, v))
}

// CustomAgentBaseIn applies the In predicate on the "custom_agent_base" field.
func CustomAgentBaseIn(vs ...string) predicate.Token {
	return predicate.Token(sql.FieldIn(FieldCustomAgentBase, vs...))
}

// CustomAgentBaseNotIn applies the NotIn predicate on the "custom_agent_base" field.
func CustomAgentBaseNotIn(vs ...string) predicate.Token {
	return predicate.Token(sql.FieldNotIn(FieldCustomAgentBase, vs...))
}

// CustomAgentBaseGT applies the GT predicate on the "custom_agent_base" field.
func CustomAgentBaseGT(v string) predicate.Token {
	return predicate.Token(sql.FieldGT(FieldCustomAgentBase, v))
}

// CustomAgentBaseGTE applies the GTE predicate on the "custom_agent_base" field.
func CustomAgentBaseGTE(v string) predicate.Token {
	return predicate.Token(sql.FieldGTE(FieldCustomAgentBase, v))
}

// CustomAgentBaseLT applies the LT predicate on the "custom_agent_base" field.
func CustomAgentBaseLT(v string) predicate.Token {
	return predicate.Token(sql.FieldLT(FieldCustomAgentBase, v))
}

// CustomAgentBaseLTE applies the LTE predicate on the "custom_agent_base" field.
func CustomAgentBaseLTE(v string) predicate.Token {
	return predicate.Token(sql.FieldLTE(FieldCustomAgentBase, v))
}

// CustomAgentBaseContains applies the Contains predicate on the "custom_agent_base" field.
func CustomAgentBaseContains(v string) predicate.Token {
	return predicate.Token(sql.FieldContains(FieldCustomAgentBase, v))
}

// CustomAgentBaseHasPrefix applies the HasPrefix predicate on the "custom_agent_base" field.
func CustomAgentBaseHasPrefix(v string) predicate.Token {
	return predicate.Token(sql.FieldHasPrefix(FieldCustomAgentBase, v))
}

// CustomAgentBaseHasSuffix applies the HasSuffix predicate on the "custom_agent_base" field.
func CustomAgentBaseHasSuffix(v string) predicate.Token {
	return predicate.Token(sql.FieldHasSuffix(FieldCustomAgentBase, v))
}

// CustomAgentBaseIsNil applies the IsNil predicate on the "custom_agent_base" field.
func CustomAgentBaseIsNil() predicate.Token {
	return predicate.Token(sql.FieldIsNull(FieldCustomAgentBase))
}

// CustomAgentBaseNotNil applies the NotNil predicate on the "custom_agent_base" field.
func CustomAgentBaseNotNil() predicate.Token {
	return predicate.Token(sql.FieldNotNull(FieldCustomAgentBase))
}

// CustomAgentBaseEqualFold applies the EqualFold predicate on the "custom_agent_base" field.
func CustomAgentBaseEqualFold(v string) predicate.Token {
	return predicate.Token(sql.FieldEqualFold(FieldCustomAgentBase, v))
}

// CustomAgentBaseContainsFold applies the ContainsFold predicate on the "custom_agent_base" field.
func CustomAgentBaseContainsFold(v string) predicate.Token {
	return predicate.Token(sql.FieldContainsFold(FieldCustomAgentBase, v))
}

// CustomAgentKeyEQ applies the EQ predicate on the "custom_agent_key" field.
func CustomAgentKeyEQ(v string) predicate.Token {
	return predicate.Token(sql.FieldEQ(FieldCustomAgentKey, v))
}

// CustomAgentKeyNEQ applies the NEQ predicate on the "custom_agent_key" field.
func CustomAgentKeyNEQ(v string) predicate.Token {
	return predicate.Token(sql.FieldNEQ(FieldCustomAgentKey, v))
}

// CustomAgentKeyIn applies the In predicate on the "custom_agent_key" field.
func CustomAgentKeyIn(vs ...string) predicate.Token {
	return predicate.Token(sql.FieldIn(FieldCustomAgentKey, vs...))
}

// CustomAgentKeyNotIn applies the NotIn predicate on the "custom_agent_key" field.
func CustomAgentKeyNotIn(vs ...string) predicate.Token {
	return predicate.Token(sql.FieldNotIn(FieldCustomAgentKey, vs...))
}

// CustomAgentKeyGT applies the GT predicate on the "custom_agent_key" field.
func CustomAgentKeyGT(v string) predicate.Token {
	return predicate.Token(sql.FieldGT(FieldCustomAgentKey, v))
}

// CustomAgentKeyGTE applies the GTE predicate on the "custom_agent_key" field.
func CustomAgentKeyGTE(v string) predicate.Token {
	return predicate.Token(sql.FieldGTE(FieldCustomAgentKey, v))
}

// CustomAgentKeyLT applies the LT predicate on the "custom_agent_key" field.
func CustomAgentKeyLT(v string) predicate.Token {
	return predicate.Token(sql.FieldLT(FieldCustomAgentKey, v))
}

// CustomAgentKeyLTE applies the LTE predicate on the "custom_agent_key" field.
func CustomAgentKeyLTE(v string) predicate.Token {
	return predicate.Token(sql.FieldLTE(FieldCustomAgentKey, v))
}

// CustomAgentKeyContains applies the Contains predicate on the "custom_agent_key" field.
func CustomAgentKeyContains(v string) predicate.Token {
	return predicate.Token(sql.FieldContains(FieldCustomAgentKey, v))
}

// CustomAgentKeyHasPrefix applies the HasPrefix predicate on the "custom_agent_key" field.
func CustomAgentKeyHasPrefix(v string) predicate.Token {
	return predicate.Token(sql.FieldHasPrefix(FieldCustomAgentKey, v))
}

// CustomAgentKeyHasSuffix applies the HasSuffix predicate on the "custom_agent_key" field.
func CustomAgentKeyHasSuffix(v string) predicate.Token {
	return predicate.Token(sql.FieldHasSuffix(FieldCustomAgentKey, v))
}

// CustomAgentKeyIsNil applies the IsNil predicate on the "custom_agent_key" field.
func CustomAgentKeyIsNil() predicate.Token {
	return predicate.Token(sql.FieldIsNull(FieldCustomAgentKey))
}

// CustomAgentKeyNotNil applies the NotNil predicate on the "custom_agent_key" field.
func CustomAgentKeyNotNil() predicate.Token {
	return predicate.Token(sql.FieldNotNull(FieldCustomAgentKey))
}

// CustomAgentKeyEqualFold applies the EqualFold predicate on the "custom_agent_key" field.
func CustomAgentKeyEqualFold(v string) predicate.Token {
	return predicate.Token(sql.FieldEqualFold(FieldCustomAgentKey, v))
}

// CustomAgentKeyContainsFold applies the ContainsFold predicate on the "custom_agent_key" field.
func CustomAgentKeyContainsFold(v string) predicate.Token {
	return predicate.Token(sql.FieldContainsFold(FieldCustomAgentKey, v))
}

// OpenaiBaseEQ applies the EQ predicate on the "openai_base" field.
func OpenaiBaseEQ(v string) predicate.Token {
	return predicate.Token(sql.FieldEQ(FieldOpenaiBase, v))
}

// OpenaiBaseNEQ applies the NEQ predicate on the "openai_base" field.
func OpenaiBaseNEQ(v string) predicate.Token {
	return predicate.Token(sql.FieldNEQ(FieldOpenaiBase, v))
}

// OpenaiBaseIn applies the In predicate on the "openai_base" field.
func OpenaiBaseIn(vs ...string) predicate.Token {
	return predicate.Token(sql.FieldIn(FieldOpenaiBase, vs...))
}

// OpenaiBaseNotIn applies the NotIn predicate on the "openai_base" field.
func OpenaiBaseNotIn(vs ...string) predicate.Token {
	return predicate.Token(sql.FieldNotIn(FieldOpenaiBase, vs...))
}

// OpenaiBaseGT applies the GT predicate on the "openai_base" field.
func OpenaiBaseGT(v string) predicate.Token {
	return predicate.Token(sql.FieldGT(FieldOpenaiBase, v))
}

// OpenaiBaseGTE applies the GTE predicate on the "openai_base" field.
func OpenaiBaseGTE(v string) predicate.Token {
	return predicate.Token(sql.FieldGTE(FieldOpenaiBase, v))
}

// OpenaiBaseLT applies the LT predicate on the "openai_base" field.
func OpenaiBaseLT(v string) predicate.Token {
	return predicate.Token(sql.FieldLT(FieldOpenaiBase, v))
}

// OpenaiBaseLTE applies the LTE predicate on the "openai_base" field.
func OpenaiBaseLTE(v string) predicate.Token {
	return predicate.Token(sql.FieldLTE(FieldOpenaiBase, v))
}

// OpenaiBaseContains applies the Contains predicate on the "openai_base" field.
func OpenaiBaseContains(v string) predicate.Token {
	return predicate.Token(sql.FieldContains(FieldOpenaiBase, v))
}

// OpenaiBaseHasPrefix applies the HasPrefix predicate on the "openai_base" field.
func OpenaiBaseHasPrefix(v string) predicate.Token {
	return predicate.Token(sql.FieldHasPrefix(FieldOpenaiBase, v))
}

// OpenaiBaseHasSuffix applies the HasSuffix predicate on the "openai_base" field.
func OpenaiBaseHasSuffix(v string) predicate.Token {
	return predicate.Token(sql.FieldHasSuffix(FieldOpenaiBase, v))
}

// OpenaiBaseIsNil applies the IsNil predicate on the "openai_base" field.
func OpenaiBaseIsNil() predicate.Token {
	return predicate.Token(sql.FieldIsNull(FieldOpenaiBase))
}

// OpenaiBaseNotNil applies the NotNil predicate on the "openai_base" field.
func OpenaiBaseNotNil() predicate.Token {
	return predicate.Token(sql.FieldNotNull(FieldOpenaiBase))
}

// OpenaiBaseEqualFold applies the EqualFold predicate on the "openai_base" field.
func OpenaiBaseEqualFold(v string) predicate.Token {
	return predicate.Token(sql.FieldEqualFold(FieldOpenaiBase, v))
}

// OpenaiBaseContainsFold applies the ContainsFold predicate on the "openai_base" field.
func OpenaiBaseContainsFold(v string) predicate.Token {
	return predicate.Token(sql.FieldContainsFold(FieldOpenaiBase, v))
}

// OpenaiKeyEQ applies the EQ predicate on the "openai_key" field.
func OpenaiKeyEQ(v string) predicate.Token {
	return predicate.Token(sql.FieldEQ(FieldOpenaiKey, v))
}

// OpenaiKeyNEQ applies the NEQ predicate on the "openai_key" field.
func OpenaiKeyNEQ(v string) predicate.Token {
	return predicate.Token(sql.FieldNEQ(FieldOpenaiKey, v))
}

// OpenaiKeyIn applies the In predicate on the "openai_key" field.
func OpenaiKeyIn(vs ...string) predicate.Token {
	return predicate.Token(sql.FieldIn(FieldOpenaiKey, vs...))
}

// OpenaiKeyNotIn applies the NotIn predicate on the "openai_key" field.
func OpenaiKeyNotIn(vs ...string) predicate.Token {
	return predicate.Token(sql.FieldNotIn(FieldOpenaiKey, vs...))
}

// OpenaiKeyGT applies the GT predicate on the "openai_key" field.
func OpenaiKeyGT(v string) predicate.Token {
	return predicate.Token(sql.FieldGT(FieldOpenaiKey, v))
}

// OpenaiKeyGTE applies the GTE predicate on the "openai_key" field.
func OpenaiKeyGTE(v string) predicate.Token {
	return predicate.Token(sql.FieldGTE(FieldOpenaiKey, v))
}

// OpenaiKeyLT applies the LT predicate on the "openai_key" field.
func OpenaiKeyLT(v string) predicate.Token {
	return predicate.Token(sql.FieldLT(FieldOpenaiKey, v))
}

// OpenaiKeyLTE applies the LTE predicate on the "openai_key" field.
func OpenaiKeyLTE(v string) predicate.Token {
	return predicate.Token(sql.FieldLTE(FieldOpenaiKey, v))
}

// OpenaiKeyContains applies the Contains predicate on the "openai_key" field.
func OpenaiKeyContains(v string) predicate.Token {
	return predicate.Token(sql.FieldContains(FieldOpenaiKey, v))
}

// OpenaiKeyHasPrefix applies the HasPrefix predicate on the "openai_key" field.
func OpenaiKeyHasPrefix(v string) predicate.Token {
	return predicate.Token(sql.FieldHasPrefix(FieldOpenaiKey, v))
}

// OpenaiKeyHasSuffix applies the HasSuffix predicate on the "openai_key" field.
func OpenaiKeyHasSuffix(v string) predicate.Token {
	return predicate.Token(sql.FieldHasSuffix(FieldOpenaiKey, v))
}

// OpenaiKeyIsNil applies the IsNil predicate on the "openai_key" field.
func OpenaiKeyIsNil() predicate.Token {
	return predicate.Token(sql.FieldIsNull(FieldOpenaiKey))
}

// OpenaiKeyNotNil applies the NotNil predicate on the "openai_key" field.
func OpenaiKeyNotNil() predicate.Token {
	return predicate.Token(sql.FieldNotNull(FieldOpenaiKey))
}

// OpenaiKeyEqualFold applies the EqualFold predicate on the "openai_key" field.
func OpenaiKeyEqualFold(v string) predicate.Token {
	return predicate.Token(sql.FieldEqualFold(FieldOpenaiKey, v))
}

// OpenaiKeyContainsFold applies the ContainsFold predicate on the "openai_key" field.
func OpenaiKeyContainsFold(v string) predicate.Token {
	return predicate.Token(sql.FieldContainsFold(FieldOpenaiKey, v))
}

// HasAgent applies the HasEdge predicate on the "agent" edge.
func HasAgent() predicate.Token {
	return predicate.Token(func(s *sql.Selector) {
		step := sqlgraph.NewStep(
			sqlgraph.From(Table, FieldID),
			sqlgraph.Edge(sqlgraph.M2O, true, AgentTable, AgentColumn),
		)
		sqlgraph.HasNeighbors(s, step)
	})
}

// HasAgentWith applies the HasEdge predicate on the "agent" edge with a given conditions (other predicates).
func HasAgentWith(preds ...predicate.Agent) predicate.Token {
	return predicate.Token(func(s *sql.Selector) {
		step := newAgentStep()
		sqlgraph.HasNeighborsWith(s, step, func(s *sql.Selector) {
			for _, p := range preds {
				p(s)
			}
		})
	})
}

// And groups predicates with the AND operator between them.
func And(predicates ...predicate.Token) predicate.Token {
	return predicate.Token(sql.AndPredicates(predicates...))
}

// Or groups predicates with the OR operator between them.
func Or(predicates ...predicate.Token) predicate.Token {
	return predicate.Token(sql.OrPredicates(predicates...))
}

// Not applies the not operator on the given predicate.
func Not(p predicate.Token) predicate.Token {
	return predicate.Token(sql.NotPredicates(p))
}
