// Code generated by ent, DO NOT EDIT.

package ent

import (
	"context"
	"errors"
	"fmt"
	"time"
	"wechat-api/ent/agent"
	"wechat-api/ent/token"

	"entgo.io/ent/dialect/sql"
	"entgo.io/ent/dialect/sql/sqlgraph"
	"entgo.io/ent/schema/field"
)

// TokenCreate is the builder for creating a Token entity.
type TokenCreate struct {
	config
	mutation *TokenMutation
	hooks    []Hook
	conflict []sql.ConflictOption
}

// SetCreatedAt sets the "created_at" field.
func (tc *TokenCreate) SetCreatedAt(t time.Time) *TokenCreate {
	tc.mutation.SetCreatedAt(t)
	return tc
}

// SetNillableCreatedAt sets the "created_at" field if the given value is not nil.
func (tc *TokenCreate) SetNillableCreatedAt(t *time.Time) *TokenCreate {
	if t != nil {
		tc.SetCreatedAt(*t)
	}
	return tc
}

// SetUpdatedAt sets the "updated_at" field.
func (tc *TokenCreate) SetUpdatedAt(t time.Time) *TokenCreate {
	tc.mutation.SetUpdatedAt(t)
	return tc
}

// SetNillableUpdatedAt sets the "updated_at" field if the given value is not nil.
func (tc *TokenCreate) SetNillableUpdatedAt(t *time.Time) *TokenCreate {
	if t != nil {
		tc.SetUpdatedAt(*t)
	}
	return tc
}

// SetDeletedAt sets the "deleted_at" field.
func (tc *TokenCreate) SetDeletedAt(t time.Time) *TokenCreate {
	tc.mutation.SetDeletedAt(t)
	return tc
}

// SetNillableDeletedAt sets the "deleted_at" field if the given value is not nil.
func (tc *TokenCreate) SetNillableDeletedAt(t *time.Time) *TokenCreate {
	if t != nil {
		tc.SetDeletedAt(*t)
	}
	return tc
}

// SetExpireAt sets the "expire_at" field.
func (tc *TokenCreate) SetExpireAt(t time.Time) *TokenCreate {
	tc.mutation.SetExpireAt(t)
	return tc
}

// SetNillableExpireAt sets the "expire_at" field if the given value is not nil.
func (tc *TokenCreate) SetNillableExpireAt(t *time.Time) *TokenCreate {
	if t != nil {
		tc.SetExpireAt(*t)
	}
	return tc
}

// SetToken sets the "token" field.
func (tc *TokenCreate) SetToken(s string) *TokenCreate {
	tc.mutation.SetToken(s)
	return tc
}

// SetNillableToken sets the "token" field if the given value is not nil.
func (tc *TokenCreate) SetNillableToken(s *string) *TokenCreate {
	if s != nil {
		tc.SetToken(*s)
	}
	return tc
}

// SetMAC sets the "mac" field.
func (tc *TokenCreate) SetMAC(s string) *TokenCreate {
	tc.mutation.SetMAC(s)
	return tc
}

// SetNillableMAC sets the "mac" field if the given value is not nil.
func (tc *TokenCreate) SetNillableMAC(s *string) *TokenCreate {
	if s != nil {
		tc.SetMAC(*s)
	}
	return tc
}

// SetOrganizationID sets the "organization_id" field.
func (tc *TokenCreate) SetOrganizationID(u uint64) *TokenCreate {
	tc.mutation.SetOrganizationID(u)
	return tc
}

// SetNillableOrganizationID sets the "organization_id" field if the given value is not nil.
func (tc *TokenCreate) SetNillableOrganizationID(u *uint64) *TokenCreate {
	if u != nil {
		tc.SetOrganizationID(*u)
	}
	return tc
}

// SetAgentID sets the "agent_id" field.
func (tc *TokenCreate) SetAgentID(u uint64) *TokenCreate {
	tc.mutation.SetAgentID(u)
	return tc
}

// SetNillableAgentID sets the "agent_id" field if the given value is not nil.
func (tc *TokenCreate) SetNillableAgentID(u *uint64) *TokenCreate {
	if u != nil {
		tc.SetAgentID(*u)
	}
	return tc
}

// SetCustomAgentBase sets the "custom_agent_base" field.
func (tc *TokenCreate) SetCustomAgentBase(s string) *TokenCreate {
	tc.mutation.SetCustomAgentBase(s)
	return tc
}

// SetNillableCustomAgentBase sets the "custom_agent_base" field if the given value is not nil.
func (tc *TokenCreate) SetNillableCustomAgentBase(s *string) *TokenCreate {
	if s != nil {
		tc.SetCustomAgentBase(*s)
	}
	return tc
}

// SetCustomAgentKey sets the "custom_agent_key" field.
func (tc *TokenCreate) SetCustomAgentKey(s string) *TokenCreate {
	tc.mutation.SetCustomAgentKey(s)
	return tc
}

// SetNillableCustomAgentKey sets the "custom_agent_key" field if the given value is not nil.
func (tc *TokenCreate) SetNillableCustomAgentKey(s *string) *TokenCreate {
	if s != nil {
		tc.SetCustomAgentKey(*s)
	}
	return tc
}

// SetOpenaiBase sets the "openai_base" field.
func (tc *TokenCreate) SetOpenaiBase(s string) *TokenCreate {
	tc.mutation.SetOpenaiBase(s)
	return tc
}

// SetNillableOpenaiBase sets the "openai_base" field if the given value is not nil.
func (tc *TokenCreate) SetNillableOpenaiBase(s *string) *TokenCreate {
	if s != nil {
		tc.SetOpenaiBase(*s)
	}
	return tc
}

// SetOpenaiKey sets the "openai_key" field.
func (tc *TokenCreate) SetOpenaiKey(s string) *TokenCreate {
	tc.mutation.SetOpenaiKey(s)
	return tc
}

// SetNillableOpenaiKey sets the "openai_key" field if the given value is not nil.
func (tc *TokenCreate) SetNillableOpenaiKey(s *string) *TokenCreate {
	if s != nil {
		tc.SetOpenaiKey(*s)
	}
	return tc
}

// SetID sets the "id" field.
func (tc *TokenCreate) SetID(u uint64) *TokenCreate {
	tc.mutation.SetID(u)
	return tc
}

// SetAgent sets the "agent" edge to the Agent entity.
func (tc *TokenCreate) SetAgent(a *Agent) *TokenCreate {
	return tc.SetAgentID(a.ID)
}

// Mutation returns the TokenMutation object of the builder.
func (tc *TokenCreate) Mutation() *TokenMutation {
	return tc.mutation
}

// Save creates the Token in the database.
func (tc *TokenCreate) Save(ctx context.Context) (*Token, error) {
	if err := tc.defaults(); err != nil {
		return nil, err
	}
	return withHooks(ctx, tc.sqlSave, tc.mutation, tc.hooks)
}

// SaveX calls Save and panics if Save returns an error.
func (tc *TokenCreate) SaveX(ctx context.Context) *Token {
	v, err := tc.Save(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Exec executes the query.
func (tc *TokenCreate) Exec(ctx context.Context) error {
	_, err := tc.Save(ctx)
	return err
}

// ExecX is like Exec, but panics if an error occurs.
func (tc *TokenCreate) ExecX(ctx context.Context) {
	if err := tc.Exec(ctx); err != nil {
		panic(err)
	}
}

// defaults sets the default values of the builder before save.
func (tc *TokenCreate) defaults() error {
	if _, ok := tc.mutation.CreatedAt(); !ok {
		if token.DefaultCreatedAt == nil {
			return fmt.Errorf("ent: uninitialized token.DefaultCreatedAt (forgotten import ent/runtime?)")
		}
		v := token.DefaultCreatedAt()
		tc.mutation.SetCreatedAt(v)
	}
	if _, ok := tc.mutation.UpdatedAt(); !ok {
		if token.DefaultUpdatedAt == nil {
			return fmt.Errorf("ent: uninitialized token.DefaultUpdatedAt (forgotten import ent/runtime?)")
		}
		v := token.DefaultUpdatedAt()
		tc.mutation.SetUpdatedAt(v)
	}
	if _, ok := tc.mutation.Token(); !ok {
		v := token.DefaultToken
		tc.mutation.SetToken(v)
	}
	if _, ok := tc.mutation.MAC(); !ok {
		v := token.DefaultMAC
		tc.mutation.SetMAC(v)
	}
	if _, ok := tc.mutation.OrganizationID(); !ok {
		v := token.DefaultOrganizationID
		tc.mutation.SetOrganizationID(v)
	}
	if _, ok := tc.mutation.AgentID(); !ok {
		v := token.DefaultAgentID
		tc.mutation.SetAgentID(v)
	}
	if _, ok := tc.mutation.CustomAgentBase(); !ok {
		v := token.DefaultCustomAgentBase
		tc.mutation.SetCustomAgentBase(v)
	}
	if _, ok := tc.mutation.CustomAgentKey(); !ok {
		v := token.DefaultCustomAgentKey
		tc.mutation.SetCustomAgentKey(v)
	}
	if _, ok := tc.mutation.OpenaiBase(); !ok {
		v := token.DefaultOpenaiBase
		tc.mutation.SetOpenaiBase(v)
	}
	if _, ok := tc.mutation.OpenaiKey(); !ok {
		v := token.DefaultOpenaiKey
		tc.mutation.SetOpenaiKey(v)
	}
	return nil
}

// check runs all checks and user-defined validators on the builder.
func (tc *TokenCreate) check() error {
	if _, ok := tc.mutation.CreatedAt(); !ok {
		return &ValidationError{Name: "created_at", err: errors.New(`ent: missing required field "Token.created_at"`)}
	}
	if _, ok := tc.mutation.UpdatedAt(); !ok {
		return &ValidationError{Name: "updated_at", err: errors.New(`ent: missing required field "Token.updated_at"`)}
	}
	if _, ok := tc.mutation.OrganizationID(); !ok {
		return &ValidationError{Name: "organization_id", err: errors.New(`ent: missing required field "Token.organization_id"`)}
	}
	if _, ok := tc.mutation.AgentID(); !ok {
		return &ValidationError{Name: "agent_id", err: errors.New(`ent: missing required field "Token.agent_id"`)}
	}
	if _, ok := tc.mutation.AgentID(); !ok {
		return &ValidationError{Name: "agent", err: errors.New(`ent: missing required edge "Token.agent"`)}
	}
	return nil
}

func (tc *TokenCreate) sqlSave(ctx context.Context) (*Token, error) {
	if err := tc.check(); err != nil {
		return nil, err
	}
	_node, _spec := tc.createSpec()
	if err := sqlgraph.CreateNode(ctx, tc.driver, _spec); err != nil {
		if sqlgraph.IsConstraintError(err) {
			err = &ConstraintError{msg: err.Error(), wrap: err}
		}
		return nil, err
	}
	if _spec.ID.Value != _node.ID {
		id := _spec.ID.Value.(int64)
		_node.ID = uint64(id)
	}
	tc.mutation.id = &_node.ID
	tc.mutation.done = true
	return _node, nil
}

func (tc *TokenCreate) createSpec() (*Token, *sqlgraph.CreateSpec) {
	var (
		_node = &Token{config: tc.config}
		_spec = sqlgraph.NewCreateSpec(token.Table, sqlgraph.NewFieldSpec(token.FieldID, field.TypeUint64))
	)
	_spec.OnConflict = tc.conflict
	if id, ok := tc.mutation.ID(); ok {
		_node.ID = id
		_spec.ID.Value = id
	}
	if value, ok := tc.mutation.CreatedAt(); ok {
		_spec.SetField(token.FieldCreatedAt, field.TypeTime, value)
		_node.CreatedAt = value
	}
	if value, ok := tc.mutation.UpdatedAt(); ok {
		_spec.SetField(token.FieldUpdatedAt, field.TypeTime, value)
		_node.UpdatedAt = value
	}
	if value, ok := tc.mutation.DeletedAt(); ok {
		_spec.SetField(token.FieldDeletedAt, field.TypeTime, value)
		_node.DeletedAt = value
	}
	if value, ok := tc.mutation.ExpireAt(); ok {
		_spec.SetField(token.FieldExpireAt, field.TypeTime, value)
		_node.ExpireAt = value
	}
	if value, ok := tc.mutation.Token(); ok {
		_spec.SetField(token.FieldToken, field.TypeString, value)
		_node.Token = value
	}
	if value, ok := tc.mutation.MAC(); ok {
		_spec.SetField(token.FieldMAC, field.TypeString, value)
		_node.MAC = value
	}
	if value, ok := tc.mutation.OrganizationID(); ok {
		_spec.SetField(token.FieldOrganizationID, field.TypeUint64, value)
		_node.OrganizationID = value
	}
	if value, ok := tc.mutation.CustomAgentBase(); ok {
		_spec.SetField(token.FieldCustomAgentBase, field.TypeString, value)
		_node.CustomAgentBase = value
	}
	if value, ok := tc.mutation.CustomAgentKey(); ok {
		_spec.SetField(token.FieldCustomAgentKey, field.TypeString, value)
		_node.CustomAgentKey = value
	}
	if value, ok := tc.mutation.OpenaiBase(); ok {
		_spec.SetField(token.FieldOpenaiBase, field.TypeString, value)
		_node.OpenaiBase = value
	}
	if value, ok := tc.mutation.OpenaiKey(); ok {
		_spec.SetField(token.FieldOpenaiKey, field.TypeString, value)
		_node.OpenaiKey = value
	}
	if nodes := tc.mutation.AgentIDs(); len(nodes) > 0 {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.M2O,
			Inverse: true,
			Table:   token.AgentTable,
			Columns: []string{token.AgentColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(agent.FieldID, field.TypeUint64),
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_node.AgentID = nodes[0]
		_spec.Edges = append(_spec.Edges, edge)
	}
	return _node, _spec
}

// OnConflict allows configuring the `ON CONFLICT` / `ON DUPLICATE KEY` clause
// of the `INSERT` statement. For example:
//
//	client.Token.Create().
//		SetCreatedAt(v).
//		OnConflict(
//			// Update the row with the new values
//			// the was proposed for insertion.
//			sql.ResolveWithNewValues(),
//		).
//		// Override some of the fields with custom
//		// update values.
//		Update(func(u *ent.TokenUpsert) {
//			SetCreatedAt(v+v).
//		}).
//		Exec(ctx)
func (tc *TokenCreate) OnConflict(opts ...sql.ConflictOption) *TokenUpsertOne {
	tc.conflict = opts
	return &TokenUpsertOne{
		create: tc,
	}
}

// OnConflictColumns calls `OnConflict` and configures the columns
// as conflict target. Using this option is equivalent to using:
//
//	client.Token.Create().
//		OnConflict(sql.ConflictColumns(columns...)).
//		Exec(ctx)
func (tc *TokenCreate) OnConflictColumns(columns ...string) *TokenUpsertOne {
	tc.conflict = append(tc.conflict, sql.ConflictColumns(columns...))
	return &TokenUpsertOne{
		create: tc,
	}
}

type (
	// TokenUpsertOne is the builder for "upsert"-ing
	//  one Token node.
	TokenUpsertOne struct {
		create *TokenCreate
	}

	// TokenUpsert is the "OnConflict" setter.
	TokenUpsert struct {
		*sql.UpdateSet
	}
)

// SetUpdatedAt sets the "updated_at" field.
func (u *TokenUpsert) SetUpdatedAt(v time.Time) *TokenUpsert {
	u.Set(token.FieldUpdatedAt, v)
	return u
}

// UpdateUpdatedAt sets the "updated_at" field to the value that was provided on create.
func (u *TokenUpsert) UpdateUpdatedAt() *TokenUpsert {
	u.SetExcluded(token.FieldUpdatedAt)
	return u
}

// SetDeletedAt sets the "deleted_at" field.
func (u *TokenUpsert) SetDeletedAt(v time.Time) *TokenUpsert {
	u.Set(token.FieldDeletedAt, v)
	return u
}

// UpdateDeletedAt sets the "deleted_at" field to the value that was provided on create.
func (u *TokenUpsert) UpdateDeletedAt() *TokenUpsert {
	u.SetExcluded(token.FieldDeletedAt)
	return u
}

// ClearDeletedAt clears the value of the "deleted_at" field.
func (u *TokenUpsert) ClearDeletedAt() *TokenUpsert {
	u.SetNull(token.FieldDeletedAt)
	return u
}

// SetExpireAt sets the "expire_at" field.
func (u *TokenUpsert) SetExpireAt(v time.Time) *TokenUpsert {
	u.Set(token.FieldExpireAt, v)
	return u
}

// UpdateExpireAt sets the "expire_at" field to the value that was provided on create.
func (u *TokenUpsert) UpdateExpireAt() *TokenUpsert {
	u.SetExcluded(token.FieldExpireAt)
	return u
}

// ClearExpireAt clears the value of the "expire_at" field.
func (u *TokenUpsert) ClearExpireAt() *TokenUpsert {
	u.SetNull(token.FieldExpireAt)
	return u
}

// SetToken sets the "token" field.
func (u *TokenUpsert) SetToken(v string) *TokenUpsert {
	u.Set(token.FieldToken, v)
	return u
}

// UpdateToken sets the "token" field to the value that was provided on create.
func (u *TokenUpsert) UpdateToken() *TokenUpsert {
	u.SetExcluded(token.FieldToken)
	return u
}

// ClearToken clears the value of the "token" field.
func (u *TokenUpsert) ClearToken() *TokenUpsert {
	u.SetNull(token.FieldToken)
	return u
}

// SetMAC sets the "mac" field.
func (u *TokenUpsert) SetMAC(v string) *TokenUpsert {
	u.Set(token.FieldMAC, v)
	return u
}

// UpdateMAC sets the "mac" field to the value that was provided on create.
func (u *TokenUpsert) UpdateMAC() *TokenUpsert {
	u.SetExcluded(token.FieldMAC)
	return u
}

// ClearMAC clears the value of the "mac" field.
func (u *TokenUpsert) ClearMAC() *TokenUpsert {
	u.SetNull(token.FieldMAC)
	return u
}

// SetOrganizationID sets the "organization_id" field.
func (u *TokenUpsert) SetOrganizationID(v uint64) *TokenUpsert {
	u.Set(token.FieldOrganizationID, v)
	return u
}

// UpdateOrganizationID sets the "organization_id" field to the value that was provided on create.
func (u *TokenUpsert) UpdateOrganizationID() *TokenUpsert {
	u.SetExcluded(token.FieldOrganizationID)
	return u
}

// AddOrganizationID adds v to the "organization_id" field.
func (u *TokenUpsert) AddOrganizationID(v uint64) *TokenUpsert {
	u.Add(token.FieldOrganizationID, v)
	return u
}

// SetAgentID sets the "agent_id" field.
func (u *TokenUpsert) SetAgentID(v uint64) *TokenUpsert {
	u.Set(token.FieldAgentID, v)
	return u
}

// UpdateAgentID sets the "agent_id" field to the value that was provided on create.
func (u *TokenUpsert) UpdateAgentID() *TokenUpsert {
	u.SetExcluded(token.FieldAgentID)
	return u
}

// SetCustomAgentBase sets the "custom_agent_base" field.
func (u *TokenUpsert) SetCustomAgentBase(v string) *TokenUpsert {
	u.Set(token.FieldCustomAgentBase, v)
	return u
}

// UpdateCustomAgentBase sets the "custom_agent_base" field to the value that was provided on create.
func (u *TokenUpsert) UpdateCustomAgentBase() *TokenUpsert {
	u.SetExcluded(token.FieldCustomAgentBase)
	return u
}

// ClearCustomAgentBase clears the value of the "custom_agent_base" field.
func (u *TokenUpsert) ClearCustomAgentBase() *TokenUpsert {
	u.SetNull(token.FieldCustomAgentBase)
	return u
}

// SetCustomAgentKey sets the "custom_agent_key" field.
func (u *TokenUpsert) SetCustomAgentKey(v string) *TokenUpsert {
	u.Set(token.FieldCustomAgentKey, v)
	return u
}

// UpdateCustomAgentKey sets the "custom_agent_key" field to the value that was provided on create.
func (u *TokenUpsert) UpdateCustomAgentKey() *TokenUpsert {
	u.SetExcluded(token.FieldCustomAgentKey)
	return u
}

// ClearCustomAgentKey clears the value of the "custom_agent_key" field.
func (u *TokenUpsert) ClearCustomAgentKey() *TokenUpsert {
	u.SetNull(token.FieldCustomAgentKey)
	return u
}

// SetOpenaiBase sets the "openai_base" field.
func (u *TokenUpsert) SetOpenaiBase(v string) *TokenUpsert {
	u.Set(token.FieldOpenaiBase, v)
	return u
}

// UpdateOpenaiBase sets the "openai_base" field to the value that was provided on create.
func (u *TokenUpsert) UpdateOpenaiBase() *TokenUpsert {
	u.SetExcluded(token.FieldOpenaiBase)
	return u
}

// ClearOpenaiBase clears the value of the "openai_base" field.
func (u *TokenUpsert) ClearOpenaiBase() *TokenUpsert {
	u.SetNull(token.FieldOpenaiBase)
	return u
}

// SetOpenaiKey sets the "openai_key" field.
func (u *TokenUpsert) SetOpenaiKey(v string) *TokenUpsert {
	u.Set(token.FieldOpenaiKey, v)
	return u
}

// UpdateOpenaiKey sets the "openai_key" field to the value that was provided on create.
func (u *TokenUpsert) UpdateOpenaiKey() *TokenUpsert {
	u.SetExcluded(token.FieldOpenaiKey)
	return u
}

// ClearOpenaiKey clears the value of the "openai_key" field.
func (u *TokenUpsert) ClearOpenaiKey() *TokenUpsert {
	u.SetNull(token.FieldOpenaiKey)
	return u
}

// UpdateNewValues updates the mutable fields using the new values that were set on create except the ID field.
// Using this option is equivalent to using:
//
//	client.Token.Create().
//		OnConflict(
//			sql.ResolveWithNewValues(),
//			sql.ResolveWith(func(u *sql.UpdateSet) {
//				u.SetIgnore(token.FieldID)
//			}),
//		).
//		Exec(ctx)
func (u *TokenUpsertOne) UpdateNewValues() *TokenUpsertOne {
	u.create.conflict = append(u.create.conflict, sql.ResolveWithNewValues())
	u.create.conflict = append(u.create.conflict, sql.ResolveWith(func(s *sql.UpdateSet) {
		if _, exists := u.create.mutation.ID(); exists {
			s.SetIgnore(token.FieldID)
		}
		if _, exists := u.create.mutation.CreatedAt(); exists {
			s.SetIgnore(token.FieldCreatedAt)
		}
	}))
	return u
}

// Ignore sets each column to itself in case of conflict.
// Using this option is equivalent to using:
//
//	client.Token.Create().
//	    OnConflict(sql.ResolveWithIgnore()).
//	    Exec(ctx)
func (u *TokenUpsertOne) Ignore() *TokenUpsertOne {
	u.create.conflict = append(u.create.conflict, sql.ResolveWithIgnore())
	return u
}

// DoNothing configures the conflict_action to `DO NOTHING`.
// Supported only by SQLite and PostgreSQL.
func (u *TokenUpsertOne) DoNothing() *TokenUpsertOne {
	u.create.conflict = append(u.create.conflict, sql.DoNothing())
	return u
}

// Update allows overriding fields `UPDATE` values. See the TokenCreate.OnConflict
// documentation for more info.
func (u *TokenUpsertOne) Update(set func(*TokenUpsert)) *TokenUpsertOne {
	u.create.conflict = append(u.create.conflict, sql.ResolveWith(func(update *sql.UpdateSet) {
		set(&TokenUpsert{UpdateSet: update})
	}))
	return u
}

// SetUpdatedAt sets the "updated_at" field.
func (u *TokenUpsertOne) SetUpdatedAt(v time.Time) *TokenUpsertOne {
	return u.Update(func(s *TokenUpsert) {
		s.SetUpdatedAt(v)
	})
}

// UpdateUpdatedAt sets the "updated_at" field to the value that was provided on create.
func (u *TokenUpsertOne) UpdateUpdatedAt() *TokenUpsertOne {
	return u.Update(func(s *TokenUpsert) {
		s.UpdateUpdatedAt()
	})
}

// SetDeletedAt sets the "deleted_at" field.
func (u *TokenUpsertOne) SetDeletedAt(v time.Time) *TokenUpsertOne {
	return u.Update(func(s *TokenUpsert) {
		s.SetDeletedAt(v)
	})
}

// UpdateDeletedAt sets the "deleted_at" field to the value that was provided on create.
func (u *TokenUpsertOne) UpdateDeletedAt() *TokenUpsertOne {
	return u.Update(func(s *TokenUpsert) {
		s.UpdateDeletedAt()
	})
}

// ClearDeletedAt clears the value of the "deleted_at" field.
func (u *TokenUpsertOne) ClearDeletedAt() *TokenUpsertOne {
	return u.Update(func(s *TokenUpsert) {
		s.ClearDeletedAt()
	})
}

// SetExpireAt sets the "expire_at" field.
func (u *TokenUpsertOne) SetExpireAt(v time.Time) *TokenUpsertOne {
	return u.Update(func(s *TokenUpsert) {
		s.SetExpireAt(v)
	})
}

// UpdateExpireAt sets the "expire_at" field to the value that was provided on create.
func (u *TokenUpsertOne) UpdateExpireAt() *TokenUpsertOne {
	return u.Update(func(s *TokenUpsert) {
		s.UpdateExpireAt()
	})
}

// ClearExpireAt clears the value of the "expire_at" field.
func (u *TokenUpsertOne) ClearExpireAt() *TokenUpsertOne {
	return u.Update(func(s *TokenUpsert) {
		s.ClearExpireAt()
	})
}

// SetToken sets the "token" field.
func (u *TokenUpsertOne) SetToken(v string) *TokenUpsertOne {
	return u.Update(func(s *TokenUpsert) {
		s.SetToken(v)
	})
}

// UpdateToken sets the "token" field to the value that was provided on create.
func (u *TokenUpsertOne) UpdateToken() *TokenUpsertOne {
	return u.Update(func(s *TokenUpsert) {
		s.UpdateToken()
	})
}

// ClearToken clears the value of the "token" field.
func (u *TokenUpsertOne) ClearToken() *TokenUpsertOne {
	return u.Update(func(s *TokenUpsert) {
		s.ClearToken()
	})
}

// SetMAC sets the "mac" field.
func (u *TokenUpsertOne) SetMAC(v string) *TokenUpsertOne {
	return u.Update(func(s *TokenUpsert) {
		s.SetMAC(v)
	})
}

// UpdateMAC sets the "mac" field to the value that was provided on create.
func (u *TokenUpsertOne) UpdateMAC() *TokenUpsertOne {
	return u.Update(func(s *TokenUpsert) {
		s.UpdateMAC()
	})
}

// ClearMAC clears the value of the "mac" field.
func (u *TokenUpsertOne) ClearMAC() *TokenUpsertOne {
	return u.Update(func(s *TokenUpsert) {
		s.ClearMAC()
	})
}

// SetOrganizationID sets the "organization_id" field.
func (u *TokenUpsertOne) SetOrganizationID(v uint64) *TokenUpsertOne {
	return u.Update(func(s *TokenUpsert) {
		s.SetOrganizationID(v)
	})
}

// AddOrganizationID adds v to the "organization_id" field.
func (u *TokenUpsertOne) AddOrganizationID(v uint64) *TokenUpsertOne {
	return u.Update(func(s *TokenUpsert) {
		s.AddOrganizationID(v)
	})
}

// UpdateOrganizationID sets the "organization_id" field to the value that was provided on create.
func (u *TokenUpsertOne) UpdateOrganizationID() *TokenUpsertOne {
	return u.Update(func(s *TokenUpsert) {
		s.UpdateOrganizationID()
	})
}

// SetAgentID sets the "agent_id" field.
func (u *TokenUpsertOne) SetAgentID(v uint64) *TokenUpsertOne {
	return u.Update(func(s *TokenUpsert) {
		s.SetAgentID(v)
	})
}

// UpdateAgentID sets the "agent_id" field to the value that was provided on create.
func (u *TokenUpsertOne) UpdateAgentID() *TokenUpsertOne {
	return u.Update(func(s *TokenUpsert) {
		s.UpdateAgentID()
	})
}

// SetCustomAgentBase sets the "custom_agent_base" field.
func (u *TokenUpsertOne) SetCustomAgentBase(v string) *TokenUpsertOne {
	return u.Update(func(s *TokenUpsert) {
		s.SetCustomAgentBase(v)
	})
}

// UpdateCustomAgentBase sets the "custom_agent_base" field to the value that was provided on create.
func (u *TokenUpsertOne) UpdateCustomAgentBase() *TokenUpsertOne {
	return u.Update(func(s *TokenUpsert) {
		s.UpdateCustomAgentBase()
	})
}

// ClearCustomAgentBase clears the value of the "custom_agent_base" field.
func (u *TokenUpsertOne) ClearCustomAgentBase() *TokenUpsertOne {
	return u.Update(func(s *TokenUpsert) {
		s.ClearCustomAgentBase()
	})
}

// SetCustomAgentKey sets the "custom_agent_key" field.
func (u *TokenUpsertOne) SetCustomAgentKey(v string) *TokenUpsertOne {
	return u.Update(func(s *TokenUpsert) {
		s.SetCustomAgentKey(v)
	})
}

// UpdateCustomAgentKey sets the "custom_agent_key" field to the value that was provided on create.
func (u *TokenUpsertOne) UpdateCustomAgentKey() *TokenUpsertOne {
	return u.Update(func(s *TokenUpsert) {
		s.UpdateCustomAgentKey()
	})
}

// ClearCustomAgentKey clears the value of the "custom_agent_key" field.
func (u *TokenUpsertOne) ClearCustomAgentKey() *TokenUpsertOne {
	return u.Update(func(s *TokenUpsert) {
		s.ClearCustomAgentKey()
	})
}

// SetOpenaiBase sets the "openai_base" field.
func (u *TokenUpsertOne) SetOpenaiBase(v string) *TokenUpsertOne {
	return u.Update(func(s *TokenUpsert) {
		s.SetOpenaiBase(v)
	})
}

// UpdateOpenaiBase sets the "openai_base" field to the value that was provided on create.
func (u *TokenUpsertOne) UpdateOpenaiBase() *TokenUpsertOne {
	return u.Update(func(s *TokenUpsert) {
		s.UpdateOpenaiBase()
	})
}

// ClearOpenaiBase clears the value of the "openai_base" field.
func (u *TokenUpsertOne) ClearOpenaiBase() *TokenUpsertOne {
	return u.Update(func(s *TokenUpsert) {
		s.ClearOpenaiBase()
	})
}

// SetOpenaiKey sets the "openai_key" field.
func (u *TokenUpsertOne) SetOpenaiKey(v string) *TokenUpsertOne {
	return u.Update(func(s *TokenUpsert) {
		s.SetOpenaiKey(v)
	})
}

// UpdateOpenaiKey sets the "openai_key" field to the value that was provided on create.
func (u *TokenUpsertOne) UpdateOpenaiKey() *TokenUpsertOne {
	return u.Update(func(s *TokenUpsert) {
		s.UpdateOpenaiKey()
	})
}

// ClearOpenaiKey clears the value of the "openai_key" field.
func (u *TokenUpsertOne) ClearOpenaiKey() *TokenUpsertOne {
	return u.Update(func(s *TokenUpsert) {
		s.ClearOpenaiKey()
	})
}

// Exec executes the query.
func (u *TokenUpsertOne) Exec(ctx context.Context) error {
	if len(u.create.conflict) == 0 {
		return errors.New("ent: missing options for TokenCreate.OnConflict")
	}
	return u.create.Exec(ctx)
}

// ExecX is like Exec, but panics if an error occurs.
func (u *TokenUpsertOne) ExecX(ctx context.Context) {
	if err := u.create.Exec(ctx); err != nil {
		panic(err)
	}
}

// Exec executes the UPSERT query and returns the inserted/updated ID.
func (u *TokenUpsertOne) ID(ctx context.Context) (id uint64, err error) {
	node, err := u.create.Save(ctx)
	if err != nil {
		return id, err
	}
	return node.ID, nil
}

// IDX is like ID, but panics if an error occurs.
func (u *TokenUpsertOne) IDX(ctx context.Context) uint64 {
	id, err := u.ID(ctx)
	if err != nil {
		panic(err)
	}
	return id
}

// TokenCreateBulk is the builder for creating many Token entities in bulk.
type TokenCreateBulk struct {
	config
	err      error
	builders []*TokenCreate
	conflict []sql.ConflictOption
}

// Save creates the Token entities in the database.
func (tcb *TokenCreateBulk) Save(ctx context.Context) ([]*Token, error) {
	if tcb.err != nil {
		return nil, tcb.err
	}
	specs := make([]*sqlgraph.CreateSpec, len(tcb.builders))
	nodes := make([]*Token, len(tcb.builders))
	mutators := make([]Mutator, len(tcb.builders))
	for i := range tcb.builders {
		func(i int, root context.Context) {
			builder := tcb.builders[i]
			builder.defaults()
			var mut Mutator = MutateFunc(func(ctx context.Context, m Mutation) (Value, error) {
				mutation, ok := m.(*TokenMutation)
				if !ok {
					return nil, fmt.Errorf("unexpected mutation type %T", m)
				}
				if err := builder.check(); err != nil {
					return nil, err
				}
				builder.mutation = mutation
				var err error
				nodes[i], specs[i] = builder.createSpec()
				if i < len(mutators)-1 {
					_, err = mutators[i+1].Mutate(root, tcb.builders[i+1].mutation)
				} else {
					spec := &sqlgraph.BatchCreateSpec{Nodes: specs}
					spec.OnConflict = tcb.conflict
					// Invoke the actual operation on the latest mutation in the chain.
					if err = sqlgraph.BatchCreate(ctx, tcb.driver, spec); err != nil {
						if sqlgraph.IsConstraintError(err) {
							err = &ConstraintError{msg: err.Error(), wrap: err}
						}
					}
				}
				if err != nil {
					return nil, err
				}
				mutation.id = &nodes[i].ID
				if specs[i].ID.Value != nil && nodes[i].ID == 0 {
					id := specs[i].ID.Value.(int64)
					nodes[i].ID = uint64(id)
				}
				mutation.done = true
				return nodes[i], nil
			})
			for i := len(builder.hooks) - 1; i >= 0; i-- {
				mut = builder.hooks[i](mut)
			}
			mutators[i] = mut
		}(i, ctx)
	}
	if len(mutators) > 0 {
		if _, err := mutators[0].Mutate(ctx, tcb.builders[0].mutation); err != nil {
			return nil, err
		}
	}
	return nodes, nil
}

// SaveX is like Save, but panics if an error occurs.
func (tcb *TokenCreateBulk) SaveX(ctx context.Context) []*Token {
	v, err := tcb.Save(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Exec executes the query.
func (tcb *TokenCreateBulk) Exec(ctx context.Context) error {
	_, err := tcb.Save(ctx)
	return err
}

// ExecX is like Exec, but panics if an error occurs.
func (tcb *TokenCreateBulk) ExecX(ctx context.Context) {
	if err := tcb.Exec(ctx); err != nil {
		panic(err)
	}
}

// OnConflict allows configuring the `ON CONFLICT` / `ON DUPLICATE KEY` clause
// of the `INSERT` statement. For example:
//
//	client.Token.CreateBulk(builders...).
//		OnConflict(
//			// Update the row with the new values
//			// the was proposed for insertion.
//			sql.ResolveWithNewValues(),
//		).
//		// Override some of the fields with custom
//		// update values.
//		Update(func(u *ent.TokenUpsert) {
//			SetCreatedAt(v+v).
//		}).
//		Exec(ctx)
func (tcb *TokenCreateBulk) OnConflict(opts ...sql.ConflictOption) *TokenUpsertBulk {
	tcb.conflict = opts
	return &TokenUpsertBulk{
		create: tcb,
	}
}

// OnConflictColumns calls `OnConflict` and configures the columns
// as conflict target. Using this option is equivalent to using:
//
//	client.Token.Create().
//		OnConflict(sql.ConflictColumns(columns...)).
//		Exec(ctx)
func (tcb *TokenCreateBulk) OnConflictColumns(columns ...string) *TokenUpsertBulk {
	tcb.conflict = append(tcb.conflict, sql.ConflictColumns(columns...))
	return &TokenUpsertBulk{
		create: tcb,
	}
}

// TokenUpsertBulk is the builder for "upsert"-ing
// a bulk of Token nodes.
type TokenUpsertBulk struct {
	create *TokenCreateBulk
}

// UpdateNewValues updates the mutable fields using the new values that
// were set on create. Using this option is equivalent to using:
//
//	client.Token.Create().
//		OnConflict(
//			sql.ResolveWithNewValues(),
//			sql.ResolveWith(func(u *sql.UpdateSet) {
//				u.SetIgnore(token.FieldID)
//			}),
//		).
//		Exec(ctx)
func (u *TokenUpsertBulk) UpdateNewValues() *TokenUpsertBulk {
	u.create.conflict = append(u.create.conflict, sql.ResolveWithNewValues())
	u.create.conflict = append(u.create.conflict, sql.ResolveWith(func(s *sql.UpdateSet) {
		for _, b := range u.create.builders {
			if _, exists := b.mutation.ID(); exists {
				s.SetIgnore(token.FieldID)
			}
			if _, exists := b.mutation.CreatedAt(); exists {
				s.SetIgnore(token.FieldCreatedAt)
			}
		}
	}))
	return u
}

// Ignore sets each column to itself in case of conflict.
// Using this option is equivalent to using:
//
//	client.Token.Create().
//		OnConflict(sql.ResolveWithIgnore()).
//		Exec(ctx)
func (u *TokenUpsertBulk) Ignore() *TokenUpsertBulk {
	u.create.conflict = append(u.create.conflict, sql.ResolveWithIgnore())
	return u
}

// DoNothing configures the conflict_action to `DO NOTHING`.
// Supported only by SQLite and PostgreSQL.
func (u *TokenUpsertBulk) DoNothing() *TokenUpsertBulk {
	u.create.conflict = append(u.create.conflict, sql.DoNothing())
	return u
}

// Update allows overriding fields `UPDATE` values. See the TokenCreateBulk.OnConflict
// documentation for more info.
func (u *TokenUpsertBulk) Update(set func(*TokenUpsert)) *TokenUpsertBulk {
	u.create.conflict = append(u.create.conflict, sql.ResolveWith(func(update *sql.UpdateSet) {
		set(&TokenUpsert{UpdateSet: update})
	}))
	return u
}

// SetUpdatedAt sets the "updated_at" field.
func (u *TokenUpsertBulk) SetUpdatedAt(v time.Time) *TokenUpsertBulk {
	return u.Update(func(s *TokenUpsert) {
		s.SetUpdatedAt(v)
	})
}

// UpdateUpdatedAt sets the "updated_at" field to the value that was provided on create.
func (u *TokenUpsertBulk) UpdateUpdatedAt() *TokenUpsertBulk {
	return u.Update(func(s *TokenUpsert) {
		s.UpdateUpdatedAt()
	})
}

// SetDeletedAt sets the "deleted_at" field.
func (u *TokenUpsertBulk) SetDeletedAt(v time.Time) *TokenUpsertBulk {
	return u.Update(func(s *TokenUpsert) {
		s.SetDeletedAt(v)
	})
}

// UpdateDeletedAt sets the "deleted_at" field to the value that was provided on create.
func (u *TokenUpsertBulk) UpdateDeletedAt() *TokenUpsertBulk {
	return u.Update(func(s *TokenUpsert) {
		s.UpdateDeletedAt()
	})
}

// ClearDeletedAt clears the value of the "deleted_at" field.
func (u *TokenUpsertBulk) ClearDeletedAt() *TokenUpsertBulk {
	return u.Update(func(s *TokenUpsert) {
		s.ClearDeletedAt()
	})
}

// SetExpireAt sets the "expire_at" field.
func (u *TokenUpsertBulk) SetExpireAt(v time.Time) *TokenUpsertBulk {
	return u.Update(func(s *TokenUpsert) {
		s.SetExpireAt(v)
	})
}

// UpdateExpireAt sets the "expire_at" field to the value that was provided on create.
func (u *TokenUpsertBulk) UpdateExpireAt() *TokenUpsertBulk {
	return u.Update(func(s *TokenUpsert) {
		s.UpdateExpireAt()
	})
}

// ClearExpireAt clears the value of the "expire_at" field.
func (u *TokenUpsertBulk) ClearExpireAt() *TokenUpsertBulk {
	return u.Update(func(s *TokenUpsert) {
		s.ClearExpireAt()
	})
}

// SetToken sets the "token" field.
func (u *TokenUpsertBulk) SetToken(v string) *TokenUpsertBulk {
	return u.Update(func(s *TokenUpsert) {
		s.SetToken(v)
	})
}

// UpdateToken sets the "token" field to the value that was provided on create.
func (u *TokenUpsertBulk) UpdateToken() *TokenUpsertBulk {
	return u.Update(func(s *TokenUpsert) {
		s.UpdateToken()
	})
}

// ClearToken clears the value of the "token" field.
func (u *TokenUpsertBulk) ClearToken() *TokenUpsertBulk {
	return u.Update(func(s *TokenUpsert) {
		s.ClearToken()
	})
}

// SetMAC sets the "mac" field.
func (u *TokenUpsertBulk) SetMAC(v string) *TokenUpsertBulk {
	return u.Update(func(s *TokenUpsert) {
		s.SetMAC(v)
	})
}

// UpdateMAC sets the "mac" field to the value that was provided on create.
func (u *TokenUpsertBulk) UpdateMAC() *TokenUpsertBulk {
	return u.Update(func(s *TokenUpsert) {
		s.UpdateMAC()
	})
}

// ClearMAC clears the value of the "mac" field.
func (u *TokenUpsertBulk) ClearMAC() *TokenUpsertBulk {
	return u.Update(func(s *TokenUpsert) {
		s.ClearMAC()
	})
}

// SetOrganizationID sets the "organization_id" field.
func (u *TokenUpsertBulk) SetOrganizationID(v uint64) *TokenUpsertBulk {
	return u.Update(func(s *TokenUpsert) {
		s.SetOrganizationID(v)
	})
}

// AddOrganizationID adds v to the "organization_id" field.
func (u *TokenUpsertBulk) AddOrganizationID(v uint64) *TokenUpsertBulk {
	return u.Update(func(s *TokenUpsert) {
		s.AddOrganizationID(v)
	})
}

// UpdateOrganizationID sets the "organization_id" field to the value that was provided on create.
func (u *TokenUpsertBulk) UpdateOrganizationID() *TokenUpsertBulk {
	return u.Update(func(s *TokenUpsert) {
		s.UpdateOrganizationID()
	})
}

// SetAgentID sets the "agent_id" field.
func (u *TokenUpsertBulk) SetAgentID(v uint64) *TokenUpsertBulk {
	return u.Update(func(s *TokenUpsert) {
		s.SetAgentID(v)
	})
}

// UpdateAgentID sets the "agent_id" field to the value that was provided on create.
func (u *TokenUpsertBulk) UpdateAgentID() *TokenUpsertBulk {
	return u.Update(func(s *TokenUpsert) {
		s.UpdateAgentID()
	})
}

// SetCustomAgentBase sets the "custom_agent_base" field.
func (u *TokenUpsertBulk) SetCustomAgentBase(v string) *TokenUpsertBulk {
	return u.Update(func(s *TokenUpsert) {
		s.SetCustomAgentBase(v)
	})
}

// UpdateCustomAgentBase sets the "custom_agent_base" field to the value that was provided on create.
func (u *TokenUpsertBulk) UpdateCustomAgentBase() *TokenUpsertBulk {
	return u.Update(func(s *TokenUpsert) {
		s.UpdateCustomAgentBase()
	})
}

// ClearCustomAgentBase clears the value of the "custom_agent_base" field.
func (u *TokenUpsertBulk) ClearCustomAgentBase() *TokenUpsertBulk {
	return u.Update(func(s *TokenUpsert) {
		s.ClearCustomAgentBase()
	})
}

// SetCustomAgentKey sets the "custom_agent_key" field.
func (u *TokenUpsertBulk) SetCustomAgentKey(v string) *TokenUpsertBulk {
	return u.Update(func(s *TokenUpsert) {
		s.SetCustomAgentKey(v)
	})
}

// UpdateCustomAgentKey sets the "custom_agent_key" field to the value that was provided on create.
func (u *TokenUpsertBulk) UpdateCustomAgentKey() *TokenUpsertBulk {
	return u.Update(func(s *TokenUpsert) {
		s.UpdateCustomAgentKey()
	})
}

// ClearCustomAgentKey clears the value of the "custom_agent_key" field.
func (u *TokenUpsertBulk) ClearCustomAgentKey() *TokenUpsertBulk {
	return u.Update(func(s *TokenUpsert) {
		s.ClearCustomAgentKey()
	})
}

// SetOpenaiBase sets the "openai_base" field.
func (u *TokenUpsertBulk) SetOpenaiBase(v string) *TokenUpsertBulk {
	return u.Update(func(s *TokenUpsert) {
		s.SetOpenaiBase(v)
	})
}

// UpdateOpenaiBase sets the "openai_base" field to the value that was provided on create.
func (u *TokenUpsertBulk) UpdateOpenaiBase() *TokenUpsertBulk {
	return u.Update(func(s *TokenUpsert) {
		s.UpdateOpenaiBase()
	})
}

// ClearOpenaiBase clears the value of the "openai_base" field.
func (u *TokenUpsertBulk) ClearOpenaiBase() *TokenUpsertBulk {
	return u.Update(func(s *TokenUpsert) {
		s.ClearOpenaiBase()
	})
}

// SetOpenaiKey sets the "openai_key" field.
func (u *TokenUpsertBulk) SetOpenaiKey(v string) *TokenUpsertBulk {
	return u.Update(func(s *TokenUpsert) {
		s.SetOpenaiKey(v)
	})
}

// UpdateOpenaiKey sets the "openai_key" field to the value that was provided on create.
func (u *TokenUpsertBulk) UpdateOpenaiKey() *TokenUpsertBulk {
	return u.Update(func(s *TokenUpsert) {
		s.UpdateOpenaiKey()
	})
}

// ClearOpenaiKey clears the value of the "openai_key" field.
func (u *TokenUpsertBulk) ClearOpenaiKey() *TokenUpsertBulk {
	return u.Update(func(s *TokenUpsert) {
		s.ClearOpenaiKey()
	})
}

// Exec executes the query.
func (u *TokenUpsertBulk) Exec(ctx context.Context) error {
	if u.create.err != nil {
		return u.create.err
	}
	for i, b := range u.create.builders {
		if len(b.conflict) != 0 {
			return fmt.Errorf("ent: OnConflict was set for builder %d. Set it on the TokenCreateBulk instead", i)
		}
	}
	if len(u.create.conflict) == 0 {
		return errors.New("ent: missing options for TokenCreateBulk.OnConflict")
	}
	return u.create.Exec(ctx)
}

// ExecX is like Exec, but panics if an error occurs.
func (u *TokenUpsertBulk) ExecX(ctx context.Context) {
	if err := u.create.Exec(ctx); err != nil {
		panic(err)
	}
}
